﻿Imports System.IO
Imports System.Net

Public Class Request

    Public Property HttpMethod() As String
        Get
            Return m_HttpMethod
        End Get
        Private Set
            m_HttpMethod = Value
        End Set
    End Property
    Private m_HttpMethod As String

    Public Property HttpVersion() As String
        Get
            Return m_HttpVersion
        End Get
        Private Set
            m_HttpVersion = Value
        End Set
    End Property
    Private m_HttpVersion As String

    Public Property LocalUrl() As String
        Get
            Return m_LocalUrl
        End Get
        Private Set
            m_LocalUrl = Value
        End Set
    End Property
    Private m_LocalUrl As String

    Public Property IPEndPoint() As IPEndPoint
        Get
            Return m_IPEndPoint
        End Get
        Set
            m_IPEndPoint = Value
        End Set
    End Property
    Private m_IPEndPoint As IPEndPoint

    Public Property Parameters() As Dictionary(Of String, String)
        Get
            Return m_Parameters
        End Get
        Private Set
            m_Parameters = Value
        End Set
    End Property
    Private m_Parameters As Dictionary(Of String, String)

    Public Property Header() As Dictionary(Of String, String)
        Get
            Return m_Header
        End Get
        Private Set
            m_Header = Value
        End Set
    End Property
    Private m_Header As Dictionary(Of String, String)

    Public Sub New(reader As StreamReader)
        Dim line = reader.ReadLine()
        Dim tokens = line.Split(" "c)

        HttpMethod = tokens(0)
        LocalUrl = tokens(1)
        HttpVersion = tokens(2)

        Header = New Dictionary(Of String, String)()
        line = reader.ReadLine()
        While line IsNot Nothing AndAlso line <> ""
            tokens = line.Split(":"c)
            Header.Add(tokens(0).Trim(), tokens(1).Trim())
            line = reader.ReadLine()
        End While

        Parameters = New Dictionary(Of String, String)()

        ' Query String
        If LocalUrl.IndexOf("?"c) <> -1 Then
            Dim parts = LocalUrl.Split(New Char() {"?"c}, 2)
            LocalUrl = parts(0)

            createParameters(parts(1))
        End If

        ' POST
        If HttpMethod.Equals("POST") Then
            Dim length = Integer.Parse(Header("Content-Length"))
            Dim content = New Char(length - 1) {}

            reader.Read(content, 0, length)

            createParameters(New String(content))
        End If
    End Sub

    Public Overrides Function ToString() As String
        Dim request = String.Format("{0} {1} {2}" & vbCr & vbLf, HttpMethod, LocalUrl, HttpVersion)

        For Each entry As KeyValuePair(Of String, String) In Header
            request += String.Format("{0}: {1}" & vbCr & vbLf, entry.Key, entry.Value)
        Next

        For Each param As KeyValuePair(Of String, String) In Parameters
            request += String.Format("{0} = {1}" & vbCr & vbLf, param.Key, param.Value)
        Next

        Return request + vbCr & vbLf
    End Function

    Private Sub createParameters(queryString As String)
        Dim params = queryString.Split("&"c)
        For Each parameter As String In params
            Dim keyValue = parameter.Split(New Char() {"="c}, 2)
            Parameters.Add(keyValue(0), keyValue(1))
        Next
    End Sub

End Class
