﻿Imports HttpServerSample

Public Class Script
    Public Property IsScriptFile() As Boolean
        Get
            Return m_IsScriptFile
        End Get
        Private Set
            m_IsScriptFile = Value
        End Set
    End Property
    Private m_IsScriptFile As Boolean

    Public Property IsPHP() As Boolean
        Get
            Return m_IsPHP
        End Get
        Private Set
            m_IsPHP = Value
        End Set
    End Property
    Private m_IsPHP As Boolean

    Private content As String
    Private request As Request

    Public Sub New(content As String, request As Request)
        IsScriptFile = request.LocalUrl.Contains(".SSS.")
        IsPHP = request.LocalUrl.EndsWith(".php")
        Me.content = content
        Me.request = request
    End Sub

    Public Overrides Function ToString() As String
        Dim generated = content

        If IsPHP Then
            Return generatePHP()
        End If

        If Not IsScriptFile Then
            Return content
        End If

        ' Parameter ersetzen
        For Each parameter As KeyValuePair(Of String, String) In request.Parameters
            Dim key = "{{" + parameter.Key + "}}"
            generated = generated.Replace(key, parameter.Value)
        Next

        ' Cookie ersetzen
        If request.Header.ContainsKey("Cookie") Then
            generated = generated.Replace("{{Cookie}}", request.Header("Cookie"))
        End If

        Return generated
    End Function

    Private Function generatePHP() As String
        Dim php = New Process()

        php.StartInfo.FileName = "php.exe"
        php.StartInfo.Arguments = "-f " + request.LocalUrl.Substring(1)
        For Each item As KeyValuePair(Of String, String) In request.Parameters
            php.StartInfo.Arguments += " " + item.Key + "=" + item.Value
        Next
        php.StartInfo.UseShellExecute = False
        php.StartInfo.RedirectStandardOutput = True
        php.Start()

        Dim generated = php.StandardOutput.ReadToEnd()

        php.WaitForExit()

        Return generated
    End Function
End Class
